
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>lucene学习-创建索引 / 憋错料</title>

    <meta name="description" content="lucene学习-创建索引 本文的lucene是基于lucene3.5版本. 使用lucene实现搜索引擎开发,核心的部分是建立索引和搜索.本节主要是记录创建索引部分的内容. 创建的索引结构如图所示. 创建索引的步骤分为以下几个步骤: 1.建立索引器IndexWriter 2.创建文档对象Document 3.建立信息对象字段Field 4.将Field对象添加到Document 5.将Document对象添加到IndexWriter对象中 下面简要介绍几个核心对象. (1).创建IndexWriter对象. IndexW">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">lucene学习-创建索引</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P>本文的lucene是基于lucene3.5版本.</p>
<p>使用lucene实现搜索引擎开发，核心的部分是建立索引和搜索。本节主要是记录创建索引部分的内容。</p>
<p>创建的索引结构如图所示。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzMzMjYwMC8yMDE0MDYvMDgyMjEwMjQzMzMzNjc0LmpwZw==.jpg"></p>
<p><P>创建索引的步骤分为以下几个步骤：</p>
<p>1、建立索引器IndexWriter</p>
<p>2、创建文档对象Document</p>
<p>3、建立信息对象字段Field</p>
<p>4、将Field对象添加到Document</p>
<p>5、将Document对象添加到IndexWriter对象中</p>
<p>下面简要介绍几个核心对象。</p>
<p>（1）、创建IndexWriter对象。</p>
<p>IndexWriter writer=new IndexWriter(directory, iwc)。</p>
<p>directory是创建的索引要保存的路径，如果要保存在硬盘中则使用Directory directory = FSDirectory.open(new<br />
File(path))创建一个directory对象。</p>
<p>如果要保存在内存中则使用：RAMDirectory directory=new RAMDirectory()创建一个directory对象。</p>
<p>（2）、创建Document对象。</p>
<p>Document doc =new<br />
Document()；创建了一个不含有任何Field的空Document，如果要要Field添加到Document中，则使用add（Field）方法即可实现。</p>
<p>doc.add(field）。</p>
<p>（3）、创建Field对象。</p>
<p>Field field=new Field（Field名称，Field内容，存储方式，索引方式）；</p>
<p>存储方式分为3种：1、完全存储（Field.Store.YES）；2、不存储（Field.Store.NO）；3、压缩存储（Field.Store.COMPRESS）。</p>
<p>索引方式分为4种：1、不索引（Field.Index.NO）；2、 Field.Index.ANALYZED<br />
；3、&nbsp;Field.Index.NOT_ANALYZED；4、Field.Index.NOT_ANALYZED_NO_NORMS</p>
<p>创建一个简单的索引程序代码如下所示：</p>
<p>?</p>
<p><TABLE><br />
  <TBODY><br />
  <TR><br />
    <TD></p>
<p>1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46<br /></TD><br />
    <TD></p>
<p><CODE>public</CODE> <CODE>void</CODE> <CODE>Index() {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>String[] ids = { </CODE><CODE>"1"</CODE><CODE>, </CODE><CODE>"2"</CODE><CODE>, </CODE><CODE>"3"</CODE><CODE>, </CODE><CODE>"4"</CODE><br />
<CODE>};</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>String[] names = { </CODE><CODE>"aa"</CODE><CODE>, </CODE><CODE>"bb"</CODE><CODE>, </CODE><CODE>"cc"</CODE><CODE>, </CODE><CODE>"dd"</CODE><br />
<CODE>};</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>String[] contents = {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>"Using AbstractJExcelView to export data to Excel file via JExcelAPI library"</CODE><CODE>,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>"Using AbstractPdfView to export data to Pdf file via Bruno Lowagie’s iText library. "</CODE><CODE>,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>"Example to integrate Log4j into the Spring MVC application. "</CODE><CODE>,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>"Using Hibernate validator (JSR303 implementation) to validate bean in Spring MVC. "</CODE><br />
<CODE>};</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>IndexWriter writer = </CODE><CODE>null</CODE><CODE>;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>try</CODE><br />
<CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Directory directory = FSDirectory.open(</CODE><CODE>new</CODE><br />
<CODE>File(path));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>// RAMDirectory directory=new RAMDirectory();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>IndexWriterConfig iwc = </CODE><CODE>new</CODE><br />
<CODE>IndexWriterConfig(Version.LUCENE_35,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>new</CODE><br />
<CODE>StandardAnalyzer(Version.LUCENE_35));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>writer = </CODE><CODE>new</CODE><br />
<CODE>IndexWriter(directory, iwc);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Document doc = </CODE><CODE>null</CODE><CODE>;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>for</CODE><br />
<CODE>(</CODE><CODE>int</CODE> <CODE>i = </CODE><CODE>0</CODE><CODE>; i &lt; ids.length; i++) {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>doc = </CODE><CODE>new</CODE><br />
<CODE>Document();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>doc.add(</CODE><CODE>new</CODE><br />
<CODE>Field(</CODE><CODE>"id"</CODE><CODE>, ids[i], Field.Store.YES,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Field.Index.NOT_ANALYZED_NO_NORMS));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>doc.add(</CODE><CODE>new</CODE><br />
<CODE>Field(</CODE><CODE>"name"</CODE><CODE>, names[i], Field.Store.YES,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Field.Index.NOT_ANALYZED_NO_NORMS));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>doc.add(</CODE><CODE>new</CODE><br />
<CODE>Field(</CODE><CODE>"contents"</CODE><CODE>, contents[i], Field.Store.YES,</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Field.Index.ANALYZED));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>SimpleDateFormat sdf = </CODE><CODE>new</CODE><br />
<CODE>SimpleDateFormat(</CODE><CODE>"yyyy-MM-dd"</CODE><CODE>);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>doc.add(</CODE><CODE>new</CODE><br />
<CODE>Field(</CODE><CODE>"date"</CODE><CODE>, sdf.format(</CODE><CODE>new</CODE><br />
<CODE>Date()),</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Field.Store.YES, Field.Index.NOT_ANALYZED));</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>// Field.Index.ANALYZED;</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>writer.addDocument(doc);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>writer.commit();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>} </CODE><CODE>catch</CODE><br />
<CODE>(IOException e) {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>e.printStackTrace();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>} </CODE><CODE>finally</CODE><br />
<CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>if</CODE><br />
<CODE>(writer != </CODE><CODE>null</CODE><CODE>) {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>try</CODE><br />
<CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>writer.close();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>} </CODE><CODE>catch</CODE><br />
<CODE>(CorruptIndexException e) {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>e.printStackTrace();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>} </CODE><CODE>catch</CODE><br />
<CODE>(IOException e) {</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>e.printStackTrace();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p></TD></TR></TBODY></TABLE></p>
<p><P>lucene学习-创建索引</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 09:41:52 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/lucene/" title="lucene">lucene</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>lucene学习-创建索引的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzkNRO0.html" rel="bookmark">lucene之创建索引代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public void createIndex() throws IOException { // 第一步采集数据:(jdbc采集数据) BookDao dao = new BookDaoImpl(); List&lt;Book&gt; queryBookList = dao.queryBookList(); // 将数据采集放到docment对象中 Document doc = null; List&lt;Document&gt; docList = new ArrayList&lt;&gt;(); f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWlAZb0.html" rel="bookmark">lucene入门创建索引&mdash;&mdash;（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.程序宏观结构图 2.创建索引过程 3.代码实现 创建索引库: 1)  创建JavaBean对象 2)  创建Docment对象 3)  将JavaBean对象所有的属性值,均放到Document对象中去,属性名可以和JavaBean相同或不同 4)  创建IndexWriter对象 5)  将Document对象通过IndexWriter对象写入索引库中 6)  关闭IndexWriter对象 Jar包: 代码: 1 // 创建索引 2 @Test 3 public void testInd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rn6B70.html" rel="bookmark">搜索引擎系列 ---lucene简介 创建索引和搜索初步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是Lucene? Lucene最初是由Doug Cutting开发的,2000年3月,发布第一个版本,是一个全文检索引擎的架构,提供了完整的查询引擎和索引引擎 :Lucene得名于Doug妻子的中名,同时这也她外祖母的姓;目前是Apache基金会的一个顶级项目,同时也是学习搜索引擎入门必知必会. Lucene 是一个 JAVA 搜索类库,它本身并不是一个完整的解决方案,需要额外的开发工作. 优点:成熟的解决方案,有很多的成功案例.apache 顶级项目,正在持续快速的进步.庞大而活跃的开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6X8rZ3.html" rel="bookmark">搜索引擎系列 -lucene简介 创建索引和搜索初步步骤</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是Lucene? Lucene最初是由Doug Cutting开发的,2000年3月,发布第一个版本,是一个全文检索引擎的架构,提供了完整的查询引擎和索引引擎 :Lucene得名于Doug妻子的中名,同时这也她外祖母的姓;目前是Apache基金会的一个顶级项目,同时也是学习搜索引擎入门必知必会. Lucene 是一个 JAVA 搜索类库,它本身并不是一个完整的解决方案,需要额外的开发工作. 优点:成熟的解决方案,有很多的成功案例.apache 顶级项目,正在持续快速的进步.庞大而活跃的开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RNXlv0.html" rel="bookmark">lucene中创建索引库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.hope.lucene; import org.apache.commons.io.FileUtils;import org.apache.lucene.document.Document;import org.apache.lucene.document.Field;import org.apache.lucene.document.TextField;import org.apache.lucene.index.IndexWriter;import org.apach			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JoWgDM.html" rel="bookmark">【Lucene】Lucene 学习之索引文件结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Lucene 索引文件结构 基本概念 索引(index) Lucene的索引由许多个文件组成,这些文件放在同一个目录下 段(segment) 一个Lucene的索引由多个段组成,段与段之间是独立的.添加新的文档时可以生成新的段,达到阈值(段的个数,段中包含的文件数等)时,不同的段可以合并. 在文件夹下,具有相同前缀的文件属于同一个段 segments.gen 和 segments_N(N表示一个具体数字,eg:segments_5)是段的元数据文件,他们保存了段的属性信息. 文档(documen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bkoqw3.html" rel="bookmark">全文检索之lucene的优化篇--创建索引库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇HelloWorld的基础上,建立一个directory的包,添加一个DirectoryTest的测试类,用来根据指定的索引目录创建目录存放指引. DirectoryTest类中的代码如下,基本上就是在HelloWorld的基础上改改就可以了. 里面一共三个方法,testDirectory(),测试创建索引库;testDirectoryFSAndRAM(),结合方法1的两种创建方式,优化;testDirectoryOptimize(),在方法2个基础上,研究索引的优化创建,减少创建的索引			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyRLzj0.html" rel="bookmark">一、创建索引之代码开发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jar包: Lucene包: lucene-core-4.10.3.jar lucene-analyzers-common-4.10.3.jar lucene-queryparser-4.10.3.jar 其它: commons-io-2.4.jar junit-4.9.jar package com.itheima.lucene; import java.io.File; import java.io.IOException; import org.apache.commons.io.File			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzOD8J0.html" rel="bookmark">一步一步跟我学习lucene（6）---lucene索引优化之多线程创建索引</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这两天工作有点忙,博客更新不及时,请大家见谅: 前面了解到lucene在索引创建的时候一个IndexWriter获取到一个读写锁,这样势在lucene创建大数据量的索引的时候,执行效率低下的问题: 查看前面文档一步一步跟我学习lucene(5)---lucene的索引构建原理可以看出,lucene索引的建立,跟以下几点关联很大: 磁盘空间大小,这个直接影响索引的建立,甚至会造成索引写入提示完成,但是没有同步的问题: 索引合并策略的选择,这个类似于sql里边的批量操作,批量操作的数量过多直接影响执			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NJ524.html" rel="bookmark" class="title">登录界面、AutoUtils 屏幕适配、自定义Edittext（显示密码可见和一键清空）和 TextInputLayout的使用。</a>
					<div>
						登录界面: AutoUtils自动屏幕适配: AutoUtils屏幕适配使用的方法 : 1.将AutoUtils类复制到要适配的项目中: 2.在程序的入口(清单文件filter):super.onCr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412vOYM.html" rel="bookmark" class="title">Android eMMC Booting&lbrack;wiki百科&rsqb;</a>
					<div>
						eMMC binaries This is the efi partition table as exists on the emmc Sector# Size Name 256 128K xload ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mZNnM.html" rel="bookmark" class="title">Setting composer minimum stability for your application</a>
					<div>
						Minimum Stability Settings Composer accepts these flags as minimum-stability settings. The default s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZnA73.html" rel="bookmark" class="title">C语言第7次作业</a>
					<div>
						1 #include&lt;stdio.h&gt; int main() { char name[50];int character[26]={0};int i=0,j;int length=0;wh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEW1NM.html" rel="bookmark" class="title">Ios UI基础02</a>
					<div>
						UIView 继承于UIView的控件都可以添加子控件 属性 superview 谁调用superview, 那么获取的就是谁的父控件 subviews subviews是用于获取所有的子控件 谁调用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDdqb9M.html" rel="bookmark" class="title">生产者-消费者问题（1）</a>
					<div>
						在计算机操作系统中,PV操作是进程管理中的难点.首先应弄清PV操作的含义:PV操作由P操作原语和V操作原语组成(原语是不可中断的过程),对信号量进行操作,具体定义如下:    P(S):①将信号量S的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjLZa0.html" rel="bookmark" class="title">网页获取用户所在城市</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; char ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DX7bM.html" rel="bookmark" class="title">HTML5 基础（１）</a>
					<div>
						一.了解HTML5文档的结构 1.文档类型 &lt;!DOCTYPE HTML&gt;                     -  指定文档类型 2.根元素 &lt;html&gt;         ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPyvZ0.html" rel="bookmark" class="title">转战网站后台与python</a>
					<div>
						这么长时间了,迷茫的大雾也逐渐散去,正如标题所写的一样,转战网站后台开发.这段时间没怎么写博客,主要还是太忙,忙着期末考试的预习,以及服务器的搭建,python的学习,还有各种各样杂七杂八的小事,就像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpNqE3.html" rel="bookmark" class="title">黑马程序员-Java基础之多态</a>
					<div>
						面向对象之多态   多 态(面向对象特征之一):函数本身就具备多态性,某一种事物有不同的具体的体现. 体现:父类引用或者接口的引用指向了自己的子类对象.//Animal a = new Cat();  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjNao4.html" rel="bookmark" class="title">Java Future模式实现</a>
					<div>
						Java Future模式简介 Future模式是Java多线程常用的模式,而且JDK也内置对Future模式的支持,比如在java.util.concurrent包下的FutureTask类.其核心 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kv1qOM.html" rel="bookmark" class="title">基于海康威视SDK javaB&sol;S</a>
					<div>
						基于海康威视SDK javaB/S 下载NetVideoActiveX23.cab文件,放在webRoot下面的codebase文件夹里 //全局变量定义 var m_iNowChanNo = -1; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nL9aK4.html" rel="bookmark" class="title">（补）4&period;生成器知识点补充和梳理</a>
					<div>
						这篇文章是对上一篇讲生成器和迭代器的文章做的补充. 回顾一下概念,什么是生成器? 生成器就是一个包涵yield关键字的函数,当这个函数被调用的时候,函数体中的代码不会被执行! 而是返回了一个迭代器.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38oK5l0.html" rel="bookmark" class="title">Windows下使用TensorFlow</a>
					<div>
						上一篇日志(http://www.cnblogs.com/huidong/p/5426556.html)写了如何在Windows下安装Docker,并且在VM上安装TensorFlow. 在Windo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzB6WdM.html" rel="bookmark" class="title">Redis学习笔记~Redis并发锁机制</a>
					<div>
						回到目录 redis客户端驱动有很多,如ServiceStack.Redis,StackExchange.Redis等等,下面我使用ServiceStack.Redis为例,介绍一下在redis驱动中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvj8jM.html" rel="bookmark" class="title">浅谈数据库的完整性</a>
					<div>
						数据库操作的时候必须要实现数据库的完整性,在实现数据库的完整性的时候,有两种方式都可以实现数据库的完整性,第一种是通过完整性的约束实现数据库的完整性,第二种就是通过用户创建自定义的触发器实现数据库的完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQbqD0.html" rel="bookmark" class="title">多线程下的进程同步&lpar;线程同步问题总结篇&rpar;</a>
					<div>
						之前写过两篇关于线程同步问题的文章(一,二),这篇中将对相关话题进行总结,本文中也对.NET 4.0中新增的一些同步机制进行了介绍. 首先需要说明的是为什么需要线程功能同步.MSDN中有这样一段话很好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeXnD0.html" rel="bookmark" class="title">集成xadmin源码到项目的正式姿势</a>
					<div>
						xadmin是强大的,但是为了更好的后期定制开发,可能会修改到xadmin的源码. 因此还是推荐将xadmin源码集成到自己的项目中. 1.pip install xadmin 安装xadmin的模块 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myo2Yn3.html" rel="bookmark" class="title">怎么才能静下心来</a>
					<div>
						不知道从什么时候开始失眠了,也许是从刚来实习就开始的吧!我知道自己怎么会失眠,因为不管发生了还是没有发生的事,只要我知道了,那就会很激动. 现在已经来北京实习一个月了,实习期肯定不是让你接项目,也不可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xXA9B0.html" rel="bookmark" class="title">关于这两天研究Java打印pdf方法的记录</a>
					<div>
						这两天在研究Java调用打印机打印PDF文件的方法,学到了不少东西,特别来记录一下. 关于Java打印网上最多的而且也是Java正统的打印方法就是使用PrintService,一套比較标准的打印代码例 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
